#include <winsock2.h>
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "encrypt.h"
#include "sockets.h"

#include "datatypes.h"
_regs regs;

char newMsg[256];
char logMsgs[1000][256];
int totalMsgs = 0;

void flushMsgs()
{
	for (int i = 0; i < totalMsgs; i++)
	{
		printf("%s", logMsgs[i]);
	}
	totalMsgs = 0;
}

void addMsg(char * msg)
{
	MEMCPY(msg, logMsgs[totalMsgs++], strlen(msg) + 1);

	if (totalMsgs == 1000)
		flushMsgs();
}

void WriteLog(char * Packet, int Length)
{
	char stringRep[17];
	memset(stringRep, 0, 17);
	int strOffset = 0;
	char t;

	sprintf(newMsg, "s2c 0000  ");
	addMsg(newMsg);

	for (int cnt = 0; cnt < Length; cnt++)
	{
		if (cnt && ((cnt & 15) == 0))
		{
			sprintf(newMsg, "  %s\ns2c %04X  ", stringRep, cnt);
			addMsg(newMsg);

			memset(stringRep, 0, 17);
			strOffset = 0;
		}
		sprintf(newMsg, "%02X ", (BYTE)Packet[cnt]);
		addMsg(newMsg);

		t = Packet[cnt];
		if ((t >= 32) && (t <= 126))
			stringRep[strOffset++] = Packet[cnt];
		else
			stringRep[strOffset++] = '.';
	}
	while ((cnt & 15) != 0)
	{
		sprintf(newMsg, "   ");
		addMsg(newMsg);
		cnt++;
	}
	sprintf(newMsg, "  %s\n\n", stringRep);
	addMsg(newMsg);
}

void ReadLog(char * Packet, int Length)
{
	char stringRep[17];
	memset(stringRep, 0, 17);
	int strOffset = 0;
	char t;

	sprintf(newMsg, "c2s 0000  ");
	addMsg(newMsg);

	for (int cnt = 0; cnt < Length; cnt++)
	{
		if (cnt && ((cnt & 15) == 0))
		{
			sprintf(newMsg, "  %s\nc2s %04X  ", stringRep, cnt);
			addMsg(newMsg);

			memset(stringRep, 0, 17);
			strOffset = 0;
		}
		sprintf(newMsg, "%02X ", (BYTE)Packet[cnt]);
		addMsg(newMsg);

		t = Packet[cnt];
		if ((t >= 32) && (t <= 126))
			stringRep[strOffset++] = Packet[cnt];
		else
			stringRep[strOffset++] = '.';
	}
	while ((cnt & 15) != 0)
	{
		sprintf(newMsg, "   ");
		addMsg(newMsg);
		cnt++;
	}
	sprintf(newMsg, "  %s\n\n", stringRep);
	addMsg(newMsg);
}

struct _settings
{
	unsigned short local_port;
	unsigned short server_port;
	unsigned long server_ip;
	char logFile[256];
	char path[256];
} settings;

void fillSettings()
{
	char buffer[256];

	// Path
	GetCurrentDirectory(256, settings.path);
	strcat(settings.path, "\\SSPROXY.INI");

	// Proxy settings
	GetPrivateProfileString("Proxy", "Log", "packets.txt", settings.logFile, 256, settings.path);

	GetPrivateProfileString("Proxy", "Port", "15000", buffer, 256, settings.path);
	settings.local_port = atoi(buffer);

	// Server settings
	GetPrivateProfileString("Server", "IP", "127.0.0.1", buffer, 256, settings.path);
	settings.server_ip = resolveHostname(buffer);

	GetPrivateProfileString("Server", "Port", "382", buffer, 256, settings.path);
	settings.server_port = atoi(buffer);
}

INADDR client;
INADDR server;

INADDR client_ping;
INADDR server_ping;

SS_ENCR ss_encr;

bool encrypting;	// true = enabled

void decrypt(char * msg, int &len)
{
	if (encrypting == false)
		return;

	ss_encr.decrypt(msg, len);
}


void main()
{
	printf("Packet-logging Proxy Server (Build 1)\n");

	// Init
	printf("Loading settings.");

	beginWinsock();

	printf(".");

	fillSettings();

	encrypting	= false;

	// Set remote addresses
	server.set(settings.server_ip, settings.server_port);
	server_ping.set(settings.server_ip, settings.server_port + 1);

	printf(".  Done.\n\n");

	printf("Mapping route to host %s:%i\n", server.getString(), htons(server.port));
	printf("Ready to rock on port %i!\n\n", settings.local_port);

	printf("Log file open: %s\n", settings.logFile);
	freopen(settings.logFile, "wt", stdout);

	// Open some ports
	UDPSocket game;
	game.create(settings.local_port);

	UDPSocket ping;
	ping.create(settings.local_port + 1);

	// Do the proxy thing
	UDPPacket * p;

	while (!kbhit())
	{
		// Game packets
		if (p = game.poll())
		{
			char buffer[520];
			int len = p->len;
			MEMCPY(p->msg, buffer, len);
			decrypt(buffer, len);

			if (p->src == server)
			{
				game.set(client);
				game.send(p->msg, p->len);

				if (buffer[0] == 0)
				{
					switch (buffer[1])
					{
					case 0x02:	// SubSpace encryption
						if (encrypting == false)
						{
							ss_encr.initializeEncryption(getLong(buffer, 2));
							encrypting = true;

							sprintf(newMsg, "s2c       SubSpace decryption enabled.\n");
							addMsg(newMsg);
						}
						break;
					case 0x07:
						game.send(p->msg, p->len);
						encrypting = false;
						break;
					};
				}

				WriteLog(buffer, len);
			}
			else
			{
				client = p->src;
				game.set(server);
				game.send(p->msg, p->len);

				if ((buffer[0] == 0) && (buffer[1] == 1) && (len == 8))
				{
					ss_encr.sentKey = getLong(buffer, 2);
					sprintf(newMsg, "c2s       Connection from %s:%i (proto %i)\n", client.getString(), htons(client.port), buffer[6]);
					addMsg(newMsg);
				}
				else
				{
					if (buffer[0] == 0)
					{
						switch (buffer[1])
						{
						case 0x07:
							game.send(p->msg, p->len);
							encrypting = false;
							break;
						};
					}
				}

				ReadLog(buffer, len);
			}

			delete p;
		}

		// Ping packets
		if (p = ping.poll())
		{
			if (p->src == server_ping)
				ping.set(client_ping);
			else
			{
				client_ping = p->src;
				ping.set(server_ping);
			}

			ping.send(p->msg, p->len);

			delete p;
		}

		SleepEx(10, true);
	}

	// Clean up
	endWinsock();

	flushMsgs();
}
